// -------------------------------------------------------------------------------- 
//!  @file  matrix.h                                                                
//!  行列演算のヘッダファイル                                                       
//                                                                                  
//   Copyright (C) 2021 lsluk, All rights reserved.                                 
//   http://vdmgr.g2.xrea.com/index.html                                            
// -------------------------------------------------------------------------------- 
#ifndef __MATRIX_H__INCLUDED__
#define __MATRIX_H__INCLUDED__

	//! 行列
	typedef struct {
		int24f8_t					m[3][3] ;						//!< 要素
	} MATRIX ;

	//! ベクトル
	typedef struct {
		int32_t						x ;								//!< ｘ座標
		int32_t						y ;								//!< ｙ座標
		int32_t						z ;								//!< ｚ座標
	} VECTOR3 ;


extern void RAMFUNC matrix_rotationX(MATRIX *p_matrix, uint8_t angle) ;
extern void RAMFUNC matrix_rotationY(MATRIX *p_matrix, uint8_t angle) ;
extern void RAMFUNC matrix_rotationZ(MATRIX *p_matrix, uint8_t angle) ;
extern void RAMFUNC matrix_mul(MATRIX *p_m0, MATRIX *p_m1, MATRIX *p_result) ;
extern void RAMFUNC matrix_trans(MATRIX *p_matrix, VECTOR3 *p_vector, VECTOR3 *p_result) ;


#endif//__MATRIX_H__INCLUDED__
